'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                IceWalk                                   |
'|                                                                          |
'|                       GDImage sprite animation.                          |
'|                                                                          |
'|     Using more than 200 clones and a twelve stage frame PNG bitmap.      |
'|                                                                          |
'|                Example of what is going on behind the hood.              |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 09-02-2009 (MM-DD-YYYY)            |
'|                        Last revised : 09-03-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "IceWalk.exe"
#OPTION VERSION5

'#OPTIMIZE SIZE
'#OPTIMIZE SPEED

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE

#INCLUDE "GDIMAGE.INC"

#INCLUDE "ZSKIN.INC"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG
'DECLARE FUNCTION zDebug LIB "zTrace.DLL" ALIAS "zDebug" (zMessage AS ASCIIZ) AS LONG

%VK_PRIOR               = &H21
%VK_NEXT                = &H22
%VK_END                 = &H23
%VK_HOME                = &H24
%VK_LEFT                = &H25
%VK_NUMPAD4             = &H64
%VK_UP                  = &H26
%VK_NUMPAD8             = &H68
%VK_RIGHT               = &H27
%VK_NUMPAD6             = &H66
%VK_DOWN                = &H28
%VK_NUMPAD2             = &H62

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------
%MAX_SPRITE             = 200
%TIMER_DELAY            = 40  '// Timer delay (animation speed)

%XMIN_SIZE              = 800 '// Window minimum width
%YMIN_SIZE              = 600 '// Window minimum height

%ID_BACKGROUND          = -999
%ID_CTRL                = -1

%IDS_WALKER             = 9

%ID_GDIMAGE             = -9

%ID_BTN_ABOUT           = -37

%ID_BTN_HELP            = -46

%ID_MULTIFRAME          = -59
%ID_GEM                 = -61

GLOBAL gnCtrl, gMainWnd AS DWORD
GLOBAL gnFocusID AS LONG
GLOBAl grAspect, grWasZoom AS SINGLE
GLOBAL gnWasAngle, gnWasAlpha, gnWasBrightness, gnWasContrast, gnWasRed, gnWasGreen, gnWasBlue, gnWasHue AS LONG
GLOBAL gnSeedAngle, gnPrevAngle AS LONG

'// This is the place where we create all the sprites being used into the GDImage control
SUB GDImageCreateSprite()
    LOCAL rc AS RECT
    LOCAL rScale AS SINGLE
    LOCAL X, Y, K, KK, hBitmap, nX, nY, nW, nH, nSizeX, nSizeY, nAlpha AS LONG
    LOCAL zFileName AS ASCIIZ * %MAX_PATH

    CALL GetClientRect(gnCtrl, rc)

    zFileName = SK_FOLDER() + "pingo2.png"

    hBitmap = ZI_CreateBitmapFromFile(zFileName, nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, 146, 150, hBitmap, ZD_ColorARGB(255, 0), %IDS_WALKER, %ZS_VISIBLE)'HIDDEN)
    CALL ZD_SetObjectFrameCount(%IDS_WALKER, nW \ nH)
    CALL ZD_SetObjectFrameToUse(%IDS_WALKER, 1, %FALSE)
'    CALL ZD_SetObjectScale(%IDS_WALKER, 1.25)
    CALL ZD_SetObjectAnchorMode(%IDS_WALKER, %ANCHOR_CENTER_HORZ_BOTTOM)


'   // The animated clone sprite objects.
    nRight& = 640
    nAlpha = 145
    FOR Y = 1 TO %MAX_SPRITE \ 10
        nRight& -= 32
        IF nAlpha < 255 THEN nAlpha += 10: IF nAlpha > 255 THEN nAlpha = 255
        FOR X = 1 TO 10 
            K += 1
            nY = Y * 5: IF Y > %MAX_SPRITE - 2 THEN nY = Y * RND(4,6): IF Y > %MAX_SPRITE - 1 THEN nY = Y * RND(5,7)
            nX = nRight& + ((RND(3,4) * Y) * X - (4 * Y))
            IF X = 1 THEN
               KK = K
'               rScale = MIN((0.5 + (0.025 * Y)), 1)
               rScale =  MIN((0.5 + (0.03 * Y)), 1)
               hBitmap = ZI_ResizeBitmapFromFile(zFileName, nW * rScale, nH * rScale)
               CALL ZD_DrawBitmapToCtrl(gnCtrl, nX, nY, hBitmap, ZD_ColorARGB(255, 0), %IDS_WALKER + KK, %ZS_HIDDEN)
            ELSE
               CALL ZD_CloneObject(%IDS_WALKER + KK, %IDS_WALKER + K, nX, nY)
            END IF
            CALL ZD_ShowObject(%IDS_WALKER + K, %FALSE)
            CALL ZD_SetObjectFrameCount(%IDS_WALKER + K, nW \ nH)
            CALL ZD_SetObjectFrameToUse(%IDS_WALKER + K, RND(1,12), %FALSE)
            CALL ZD_SetObjectAnchorMode(%IDS_WALKER + K, %ANCHOR_CENTER_HORZ_BOTTOM)

'           // Add a little translucency to distant pinguins
'//Emachine            CALL ZD_SetObjectAlpha(%IDS_WALKER + K, nAlpha, %FALSE)

        NEXT
    NEXT
    CALL ZD_SetObjectScale(%IDS_WALKER, 1.25)
    CALL ZD_SetObjectZorder(%IDS_WALKER, %ZD_ORDER_TOP)

'   // Make sure that the composited background is still at the bottom of z-order
    CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM)

'   // We put the GDImage focus on the %IDS_WALKER 
    CALL ZI_SetObjectFocusID(%IDS_WALKER)
    gnFocusID = %IDS_WALKER
  
END SUB

DECLARE FUNCTION SetWindowText LIB "USER32.DLL" ALIAS "SetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ) AS LONG

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZIMAGE3D"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0 ' %WS_EX_LAYERED '// Let the OS take care of the region for us (Doesn't work on XP)
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = EXE.Name$
       gMainWnd = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF gMainWnd THEN
       
          IF (dwExStyle AND %WS_EX_LAYERED) THEN '// Warning this doesn't work on XP (only on VISTA and Windows 7)
             CALL SetLayeredWindowAttributes(gMainWnd, RGB(255,0,255), 255, %LWA_ALPHA OR %LWA_COLORKEY)
          END IF

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(gMainWnd, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(gMainWnd, zsExePath() + "IceSkin.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls()

          CALL GDImageBackground()
  
'         // This is the place where we create all the sprites being used into the GDImage control
          CALL GDImageCreateSprite()
'CALL ZI_BoostSprite(2,1)

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(0)

          CALL SetTimer(gMainWnd, 1, %TIMER_DELAY, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(gMainWnd, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND
          CALL KillTimer(gMainWnd, 1)

          FUNCTION = msg.wParam

       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Add child controls to main window
SUB AddChildControls()

    LOCAL hCtrl, imgW, imgH AS LONG
    LOCAL sLabel, sImageName AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL vgW, vgH AS LONG
    LOCAL rw AS RECT

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

'   OpenGL section
'   Create the Visual graphic control
    vgW = 792: vgH = 260 ' 460
    'vgW = 0: vgH = 0
    zClass =  $GDImageClassName ' $GLImageClassName
    Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
    StyleEx& = 0 '%WS_EX_STATICEDGE
    gnCtrl = CreateWindowEx(StyleEx&, _
                           zClass, _                  ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           4, _                       ' initial x position
                           297, _                     ' initial y position
                           vgW, _                     ' Calculate Window Width
                           vgH, _                     ' Calculate Window Height
                           gMainWnd, _                ' parent window handle
                           %ID_CTRL, _                ' ControlID
                           zsInstance(), _            ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   Anchor the control to match the size of the parent window
    CALL zSetAnchorMode(gnCtrl, %ANCHOR_HEIGHT_WIDTH)
    
'   ___________________

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "GDImage.png"), "", 602, 40, 191, 56, %ID_GDIMAGE, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

'   ___________________


'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(gMainWnd, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(gMainWnd, %ID_LED), %HWND_TOP)

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Help.png"), zCXSYSICON(0,0), zCYSYSICON(0,0), %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_About.png"), "", 668, 561, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")
  
    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Show the hord", 24, 557, 120, 22, %ID_MULTIFRAME, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Sprite multi-frame")

    sImageName = SK_FOLDER() + "Gem.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    CALL GetWindowRect(gMainWnd, rw)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", ((rw.nRight - rw.nLeft) - imgW) \ 2, 0, imgW, imgH, %ID_Gem, 0)
    '//CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

END SUB

SUB GdimageResize()
    LOCAL lpr AS RECT, nSizeX, nSizeY AS LONG
    CALL GDImageBackground()
END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    IF ChangeBackground THEN
       CALL GDImageBackground()
       CALL zUpdateWindow(hWnd, 0)
    END IF
END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT, p AS POINTAPI
    LOCAL K, hDC, hList, nItem, Img AS LONG
    LOCAL sDataString AS STRING

    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COPYDATA

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_HELP

         CASE %ID_MULTIFRAME
              FOR K = 1 TO %MAX_SPRITE
                  CALL ZD_SetObjectVisibility(%IDS_WALKER + K, zGetCheckButtonStatus(zGetMainItem(%ID_MULTIFRAME)))
              NEXT

         END SELECT
         IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)
         CALL GDImageResize()

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_TIMER
         CALL RenderAnimation()

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB GDImageBackground()
    LOCAL lp AS POINTAPI, rc, lpr AS RECT
    LOCAL hIC, hDC, graphics, nBackground, Img, ImgW, ImgH, xP, yP, xS, yS, bmW, bmH, CtrlW, CtrlH, bBitmapFound AS LONG

    CALL GetWindowRect(gnCtrl, lpr)
    lp.x = lpr.nLeft: lp.y = lpr.nTop
    CALL ScreenToClient(gMainWnd, lp)
'    IF zGetCheckButtonStatus(zGetMainItem(%ID_COMPOSITED)) THEN

       CALL GetClientRect(gMainWnd, rc)
       CtrlW = lpr.nRight - lpr.nLeft
       CtrlH = lpr.nBottom - lpr.nTop
       nBackground = ZD_GetObjectBitmap(%ID_BACKGROUND)
       IF nBackground THEN
          bBitmapFound = -1
          CALL ZI_GetBitmapSize(nBackground, bmW, bmH)
          IF bmW < CtrlW OR bmH < CtrlH THEN bmW = 0: bmH = 0
       END IF
       IF bmW THEN
          hIC = zDisplayDC()
          hDC = CreateCompatibleDC(hIC)
          CALL SelectObject(hDC, nBackground)
          CALL DeleteDC(hIC)
       ELSE
          '// Use default 1400 x 900
          IF CtrlW > 1400 OR CtrlH > 900 THEN
             hDC = ZI_Create32bitDC(CtrlW, CtrlH, &HFF000000&)
          ELSE
             hDC = ZI_Create32bitDC(1400, 900, &HFF000000&)
          END IF
       END IF

       nBackground = ZI_GetBitmapFromDC(hDC)
       IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
'          CALL ZI_SetProperty(gnCtrl, %ZI_GradientTop, 0)
'          CALL ZI_SetProperty(gnCtrl, %ZI_GradientBottom, 0)
          Img = zGetProperty(gMainWnd, %FORM_Center): CALL zGetImageSize(Img, ImgW, ImgH)
          CALL zComputeAspect(ImgW, ImgH, rc.nRight, rc.nBottom, xP, yP, xS, yS)
         '// Set up stretching QualityMode
          CALL GdipSetInterpolationMode(graphics, 2)
          CALL GdipDrawImageRectRectI(graphics, Img, xP - lp.x, yP - lp.y, xS, yS, 0, 0, ImgW, ImgH, %UnitPixel, 0)
          CALL ZD_DrawBitmapToCtrl(gnCtrl, 0, 0, nBackground, &HFFFFFFFF, %ID_BACKGROUND, %ZS_VISIBLE)
          CALL GdipDeleteGraphics(graphics)

'         CALL ZD_CopyToBackground(gnCtrl, %ID_BACKGROUND, 0, 0)
'         or
          CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM) '// Make sure the background is at the bottom of z-order
          CALL ZD_SetObjectLocked(%ID_BACKGROUND, %TRUE)

       END IF
       IF hDC THEN CALL DeleteDC(hDC)
'    ELSE
'       CALL ZI_SetProperty(gnCtrl, %ZI_GradientTop, RGB(0,0,0))
'       CALL ZI_SetProperty(gnCtrl, %ZI_GradientBottom, RGB(128,128,128))
'       IF ZD_IsObjectVisible(%ID_BACKGROUND) THEN ZD_SetObjectVisibility(%ID_BACKGROUND, %FALSE)
'    END IF

END SUB

'// This is the callback being used for all the animations
SUB RenderAnimation()
    STATIC Flip AS LONG

    '// Draw active frame to memory DC
    Flip = NOT Flip 
    IF Flip THEN
       CALL RedrawClone()
    ELSE '// Redraw everything
       CALL RedrawSprite()
    END IF

END SUB

SUB RedrawClone()
    LOCAL K, nFrame AS LONG

    FOR K = 1 TO %MAX_SPRITE
        nFrame = ZD_GetObjectFrameToUse(%IDS_WALKER + K) + 1: IF nFrame > ZD_GetObjectFrameCount(%IDS_WALKER + K) THEN nFrame = 1
        CALL ZD_SetObjectFrameToUse(%IDS_WALKER + K, nFrame, %FALSE)
    NEXT

END SUB

'// Update the main animation
SUB RedrawSprite()
    LOCAL nFrame AS LONG

    nFrame = ZD_GetObjectFrameToUse(%IDS_WALKER) + 1: IF nFrame > ZD_GetObjectFrameCount(%IDS_WALKER) THEN nFrame = 1
    CALL ZD_SetObjectFrameToUse(%IDS_WALKER, nFrame, %TRUE)

END SUB
